<div class="card">
  <p-table
    [value]="revenues"
    [lazy]="true"
    (onLazyLoad)="loadRevenues($event)"
    dataKey="id"
    responsiveLayout="stack"
    [breakpoint]="'960px'"
    [paginator]="true"
    [rows]="10"
    [rowsPerPageOptions]="[5, 10, 25, 50]"
    [totalRecords]="totalRecords"
    [loading]="loading"
    [globalFilterFields]="['station', 'direction', 'category']"
  >
    <ng-template pTemplate="header">
      <tr>
        <th pSortableColumn="station">Estacion
          <p-sortIcon field="station"></p-sortIcon>
        </th>
        <th pSortableColumn="direction">Dirección
          <p-sortIcon field="direction"></p-sortIcon>
        </th>
        <th pSortableColumn="category">Categoría
          <p-sortIcon field="category"></p-sortIcon>
        </th>
        <th pSortableColumn="date">Fecha
          <p-sortIcon field="date"></p-sortIcon>
        </th>
        <th pSortableColumn="hour">Hora
          <p-sortIcon field="hour"></p-sortIcon>
        </th>
        <th pSortableColumn="quantity">Cantidad
          <p-sortIcon field="quantity"></p-sortIcon>
        </th>
        <th pSortableColumn="value">Valor
          <p-sortIcon field="value"></p-sortIcon>
        </th>
      </tr>
      <tr>
        <th>
          <p-columnFilter field="station" matchMode="equals" [showMenu]="false">
            <ng-template pTemplate="filter" let-value let-filter="filterCallback">
              <input type="text" pInputText #stationFilter [ngModel]="value"
                             (change)="filter(stationFilter.value)"
              />
            </ng-template>
          </p-columnFilter>
        </th>
        <th>
          <p-columnFilter field="direction" matchMode="equals" [showMenu]="false">
            <ng-template pTemplate="filter" let-value let-filter="filterCallback">
              <input type="text" pInputText #directionFilter [ngModel]="value"
                     (change)="filter(directionFilter.value)"
              />
            </ng-template>
          </p-columnFilter>
        </th>
        <th>
          <p-columnFilter field="category" matchMode="equals" [showMenu]="false">
            <ng-template pTemplate="filter" let-value let-filter="filterCallback">
              <p-dropdown [ngModel]="value" [options]="statuses" (onChange)="filter($event.value)" [appendTo]="'body'"
                          placeholder="Todas">
                <ng-template let-option pTemplate="item">
                  {{option}}
                </ng-template>
              </p-dropdown>
            </ng-template>
          </p-columnFilter>
        </th>
        <th>
          <p-columnFilter field="date" [showMenu]="false" matchMode="equals">
            <ng-template pTemplate="filter" let-value let-filter="filterCallback">
              <p-calendar [ngModel]="value" (onSelect)="filter($event)" [appendTo]="'body'"></p-calendar>
            </ng-template>
          </p-columnFilter>
        </th>
        <th>
          <p-columnFilter field="hour" matchMode="equals" [showMenu]="false">
            <ng-template pTemplate="filter" let-value let-filter="filterCallback">
              <p-inputNumber #hourFilter [ngModel]="value" [min]="0" [max]="24"
                             (keydown.enter)="filter(hourFilter.value)" (onBlur)="filter(hourFilter.value)"
              ></p-inputNumber>
            </ng-template>
          </p-columnFilter>
        </th>
        <th>
          <p-columnFilter field="quantity" matchMode="equals" [showMenu]="false">
            <ng-template pTemplate="filter" let-value let-filter="filterCallback">
              <p-inputNumber #quantityFilter [ngModel]="value" [min]="0"
                             (keydown.enter)="filter(quantityFilter.value)" (onBlur)="filter(quantityFilter.value)">
              </p-inputNumber>
            </ng-template>
          </p-columnFilter>
        </th>
        <th>
          <p-columnFilter type="numeric" matchMode="equals" field="value" [showMenu]="false">
            <ng-template pTemplate="filter" let-value let-filter="filterCallback">
              <p-inputNumber #valueFilter [ngModel]="value" [min]="0"
                             (keydown.enter)="filter(valueFilter.value)" (onBlur)="filter(valueFilter.value)">
              </p-inputNumber>
            </ng-template>
          </p-columnFilter>
        </th>
      </tr>
    </ng-template>
    <ng-template pTemplate="body" let-revenue>
      <tr>
        <td><span class="p-column-title">Estación: </span>{{revenue.station}}</td>
        <td><span class="p-column-title">Dirección: </span>{{revenue.direction}}</td>
        <td><span class="p-column-title">Categoría: </span>{{revenue.category}}</td>
        <td><span class="p-column-title">Fecha: </span>{{revenue.date | date:'yyyy-MM-dd'}}</td>
        <td><span class="p-column-title">Hora: </span>{{revenue.hour }}</td>
        <td><span class="p-column-title">Cantidad: </span>{{revenue.quantity}}</td>
        <td><span class="p-column-title">Valor: </span>{{revenue.value | currency:'':'symbol':'1.0-0'  }}</td>
      </tr>
    </ng-template>

    <ng-template pTemplate="emptymessage">
      <tr>
        <td colspan="7" class="text-center">No se encontraron datos.</td>
      </tr>
    </ng-template>

  </p-table>
</div>
